#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QLineEdit>
#include <QProcess>
#include <QInputDialog>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    setWindowIcon(QIcon(":/images/bash.png"));
    setWindowFlags(Qt::Dialog | Qt::MSWindowsFixedSizeDialogHint); //Данная строчка запрещает изменение размеров окна
    ui->plainTextEdit->appendPlainText(PATH);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::slot_finished(int exitCode)
{
    ui->plainTextEdit->appendPlainText(QString("Process exited with code %1").arg(exitCode));
    qobject_cast<QProcess*>(sender())->deleteLater();
}

void MainWindow::slot_readyRead()
{
    QByteArray output = qobject_cast<QProcess*>(sender())->readAllStandardError();
    if(!output.isEmpty())
        ui->plainTextEdit->appendPlainText(QString("\nERROR: %1\n").arg(QString::fromUtf8(output)));
        output = qobject_cast<QProcess*>(sender())->readAllStandardOutput();
        if(!output.isEmpty())
        ui->plainTextEdit->appendPlainText(QString::fromUtf8(output));
}

void MainWindow::on_pushButton_clicked()
{
    QString command = ui->lineEdit->text();
    QProcess* p = new QProcess();
    p->setProcessEnvironment(QProcessEnvironment::systemEnvironment());

    connect(p,&QProcess::readyReadStandardError,this,&MainWindow::slot_readyRead);
    connect(p,&QProcess::readyReadStandardOutput,this,&MainWindow::slot_readyRead);
    connect(p,static_cast<void (QProcess::*)(int)>(&QProcess::finished),this,&MainWindow::slot_finished);
    p->start("sh", QStringList() << "-c" << QString(command));
    ui->plainTextEdit->appendPlainText(PATH);
}

void MainWindow::keyPressEvent(QKeyEvent *event)
{
    int key=event->key();
    QString str = QString(QChar(key));
    if (key>=Qt::Key_0 && key<=Qt::Key_Enter) {
        ui->plainTextEdit->clear();
        on_pushButton_clicked();
    }
}
